<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Mikko Linko - Final Project</title>
    <style>
        body {
            font-family: Arial, sans-serif;
            margin: 0;
            padding: 0;
        }

        header {
            background-color: #333;
            color: #fff;
            padding: 10px;
            text-align: center;
        }

        p {
            width: 500px;
        }

        img {
            width: 1500px;
        }

        nav {
            background-color: #eee;
            display: flex;
            justify-content: space-around;
            align-items: center;
            height: 50px;
        }

        nav a {
            text-decoration: none;
            color: #333;
            font-weight: bold;
        }

        nav a.selected {
            color: #ff0000; /* Change to the desired color */
        }

        section {
            display: flex;
            padding: 20px;
        }

        ul {
            list-style-type: none;
            padding: 0;
            margin-right: 10px;
            width: 100px;
        }

        ul li {
            margin-bottom: 10px;
        }

        div {
            flex: 1;
            margin-left: 100px
        }

        div h2{
            margin-top: 100px; /* Adjust the margin as needed */
        }
    </style>
</head>
<body>

<header>
    <h1>Mikko Linko - Digital Fabrication</h1>
    <nav>
        <a href="index.html" >Weekly Assignements</a>
        <a href="final-project.html" class="selected">Final Project</a>
        <a href="about_me.html">About Me</a>
        <a href="previous_projects.html">Previous Projects</a>
    </nav>
</header>

<section>
    <ul>
        <li><a>Sketch</a></li>
    </ul>

    <div>
        <h2>Sketch</h2>
        <p>A double gantry cnc router where all of the electronics are concentrateed in the main "head" and the rest can be scaled
            to fit the users needs.
        </p>
        <img src="Images/Sketch_render.10.jpg" alt="Sketch_render.10">
        <img src="Images/Sketch_render.11.jpg" alt="Sketch_render.11">
        <img src="Images/Sketch_render.12.jpg" alt="Sketch_render.12">
        <img src="Images/Sketch_render.13.jpg" alt="Sketch_render.13">

        <h2>Gears</h2>

        <p>
            Both of the gantries are operated with gears, while rack and pinion setup is nice it
            does have some problems. Backlash is caused by the tiny amount of play between the rack
            and pinion, however it can be minimized with the usage of helical gears instead of spur
            gears. The use of helical gears should make the operation more smooth and precise, but
            it also introduces axial thrust to the system, which might become an issue.
        </p>
            
        <p>
            Another concern is that chips from the machining might end up on the rack gears
            causing premature wear and loss of precision. I am not really sure if this is an actual
            concern, but it could be minimized by installing the racks on the bottom side of the 
            gantries, so that majority of the chips would just fall off, but on the other hand 
            smaller chips like dust could still get stuck there, and it would be closer to the 
            actual machining operation.
        </p>

        <h2>Software</h2>

        <p>
            My plan is to run the machine using GRBL https://github.com/grbl/grbl and according
            to it's github page it can be ran with Atmega 328, which is commonly found in arduino
            Uno boards, though the chip itself is a lot cheaper and gives more possibilites
            of fitting it well in the machine.
        </p>

        <h2>Schedule</h2>

        <h2>Week 20 </h2>
        <p>mon work on GUI</p>
        <p>tue Design X carriage</p>
        <p>wed Finish Design X carriage / print X carriage</p>
        <P>thu Finish printing X carriage / work on GUI</P>
        <p>fri Assemble and test X carriage / work on GUI</p>

        <h2>Week 21 </h2>
        <p>mon Finish test version of GUI</p>
        <p>tue Test X carriage with GUI / design boards</p>
        <p>wed finish 1st version of boards / design 1st version of all parts</p>
        <p>thu Design 1st version of all parts</p>
        <p>fri finish design 1st version of all parts / start printing over the weekend</p>

        <h2>Week 22 </h2>
        <p>mon make boards/ assemble 1st version</p>
        <p>tue write code / test</p>
        <p>wed write code / test</p>
        <p>thu design 2nd version of all parts if needed</p>
        <p>fri finish designing 2nd version start printing parts over the weekend</p>

        <h2>Week 23 </h2>
        <p>mon</p>
        <p>tue</p>
        <p>wed</p>
        <p>thu</p>
        <p>fri</p>

        <h2>Week 20</h2>

        <p>
            Using p5.js I have started working on the basics of the interface, it currently has a draggable representation of the gantries, the interface adjusts dynamically to the screen, and the size of the
            "bed" can be adjusted. The main thing that it has is translating the mouse cordinates to a more understandable numbers that represent the bed.
            <a href="UserInterface/Index.html" >UserInterface</a>
        </p>

        <img src="Images\Final\GUI1.jpg" alt="GUI1">

        <p>
            I started designing a singular gantry carriage to test the fitment of parts, but before that I did a rough sketch to figure out where all parts are, so I the carriage represents the measurements
            of the final project.

            Some of the design concerns while doing it was allocating space for all the parts, thus I initially divided it into 4 segments separated by the gantries, however it doesn't neatly fit into those
            segments, but the main idea was to have a segments for: gantry stepper motors, tool stepper motor, PCBs and tool sleeve. The tool sleeve is a new addition, it is there just to reserve a large enough
            space for the tool, and in worst case scenario the tool part can be entirely skipped if time constrains are too pressing, and instead just focus on the machines movement.
            The rack and pinion were made with <a href="https://evolventdesign.com/pages/spur-gear-generator" >Gear generator</a>, while I have no concrete idea what a single step corresponds on the stepper motor,
            according the internet the most common would be 1.8* degrees, so I made the gear have 20 teeth and the rack has a tooth/5mm to make counting distance from steps easier, however because of this the gear
            module is very weird and random as I just scaled the gears up as necessary.
        </p>

        <img src="Images\Final\RhinoWholeAssembly.jpg" alt="RhinoWholeAssembly">

        <p>
            From the rough draft I then separated just a single gantry and made a simplified and working carriage from it. I also had to make some stand-ins for parts like the wheels.
        </p>

        <img src="Images\Final\RhinoXCarriage.jpg" alt="RhinoXCarriage">

        <p>
            After slicing all the parts and starting to print them, it was obvious  that it would take a bit longer than expected, I perhaps used too fine of a layerheight of 0.12, and if I have to re-do some of the
            parts, and future when makign the v1, I should go for larger layers to make the process faster, as especially if something does go wrong, the process of printing the part can take multiple days, even this
            single carrier takes 23h of printing time in total.
        </p>

        <img src="Images\Final\RackGear1.jpg" alt="RackGear1">
        <img src="Images\Final\RackGear2.jpg" alt="RackGear2">

        <img src="Images\Final\MainAssembly1.jpg" alt="MainAssembly1">
        <img src="Images\Final\MainAssembly2.jpg" alt="MainAssembly2">

        <p>
            I made it so m5 nuts can be placed in recesses in the main assembly, and the bolts should hold it together, and also act as axles for the wheels. The motor itself has threads in it so the motor is
            just mounted with m3 bolts through some holes in the bracket.

        </p>

        <p>
            I had to make a complete new carriage and rack gears due to fitment issues, the 2020 extrusion profile that I was referencing was something that I got online, and it was clearly the wrong one when 
            compared to the actual extrusion I had at hand. While changing the carriage to fit the actual extrusion profile, I also added some flanges for the different carriage parts to fit into eachother so it
            would be more rigid, which turned out pretty well. The new carriage over all fits pretty well, it rattles a bit when moving, but I suspect that is because the wheels do not yet have bearings, so
            because of that they cannot be tightened all the way. The new rack gears are a bit too loose on the extrusion, and there is a bit of play, another frustrating part is that the rack gears apparently are
            a bit short, when all of the are put into the groove they are missing about 3mm in length total. The fitment of the rack and gear could also be a bit tighter. A side note: the parts seem to have a slight
            x-layer shift from 3d printing, which is also affecting the results, the shift is about 3*.
        </p>

        <img src="Images\Final\TotalFitment.jpg" alt="TotalFitment">

        <img src="Images\Final\GearFitment.jpg" alt="GearFitment">

        <img src="Images\Final\RackFitment.jpg" alt="RackFitment">

        <p>
            I made an arduino script to control the stepper motor, you can use serial to type commands to it. The commands include enabling the motor, taking specified amount of steps in either direction and
            setting the delay between steps. However it does not have acceleration built-in to it yet, which is not good especially for faster speeds, and because it works by having delays between the steps, it
            can't be used with multiple motors simultaneously, which is something I have to address. In order to use multiple motors and drive the msimultaneously, the script should use timers instead of delay, due
            to the motors needing to move at the same time but at different speeds.
        </p>

        <p>
            The pinion gear has 20 teeth, and the rack gear has a teeth/5mm, which should result in the carriage moving 10cm with a full rotation, to achieve full rotation the motor needs 200 steps according to it's
            data sheet. The driver operates at 1/16 steps, so in total the stepper should be given 3200 steps to move 10cm. A quick measurement shows it to be atleast in the correct ball-park.
        </p>

        <img src="Images\Final\CarriageTest.jpg" alt="CarriageTest">

        <video width="1280" height="720" controls>
            <source src="Videos/CarriageMovement.mp4" type="video/mp4">
          Your browser does not support the video tag.
        </video>

        <p>
            Making the networking features of the interface to work was quite a task, but eventually I got them running, the problem is that the stepper control on the esp32 cannot yet process the g-code, my aim
            is to get G00 command working asap, just so I can test the unctionality with it.
        </p>

        <img src="Images\Final\NetworkTest.jpg" alt="NetworkTest">
    </div>
</section>

</body>
</html>
